---
layout: global
title: INVALID_AGGREGATE_FILTER error class
displayTitle: INVALID_AGGREGATE_FILTER error class
license: |
  Licensed to the Apache Software Foundation (ASF) under one or more
  contributor license agreements.  See the NOTICE file distributed with
  this work for additional information regarding copyright ownership.
  The ASF licenses this file to You under the Apache License, Version 2.0
  (the "License"); you may not use this file except in compliance with
  the License.  You may obtain a copy of the License at

     http://www.apache.org/licenses/LICENSE-2.0

  Unless required by applicable law or agreed to in writing, software
  distributed under the License is distributed on an "AS IS" BASIS,
  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  See the License for the specific language governing permissions and
  limitations under the License.
---

<!--
  DO NOT EDIT THIS FILE.
  It was generated automatically by `org.apache.spark.SparkThrowableSuite`.
-->

[SQLSTATE: 42903](sql-error-conditions-sqlstates.html#class-42-syntax-error-or-access-rule-violation)

The FILTER expression `<filterExpr>` in an aggregate function is invalid.

This error class has the following derived error classes:

## CONTAINS_AGGREGATE

Expected a FILTER expression without an aggregation, but found `<aggExpr>`.

## CONTAINS_WINDOW_FUNCTION

Expected a FILTER expression without a window function, but found `<windowExpr>`.

## NON_DETERMINISTIC

Expected a deterministic FILTER expression.

## NOT_BOOLEAN

Expected a FILTER expression of the BOOLEAN type.


