---
layout: global
title: INVALID_INTERVAL_FORMAT error class
displayTitle: INVALID_INTERVAL_FORMAT error class
license: |
  Licensed to the Apache Software Foundation (ASF) under one or more
  contributor license agreements.  See the NOTICE file distributed with
  this work for additional information regarding copyright ownership.
  The ASF licenses this file to You under the Apache License, Version 2.0
  (the "License"); you may not use this file except in compliance with
  the License.  You may obtain a copy of the License at

     http://www.apache.org/licenses/LICENSE-2.0

  Unless required by applicable law or agreed to in writing, software
  distributed under the License is distributed on an "AS IS" BASIS,
  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  See the License for the specific language governing permissions and
  limitations under the License.
---

<!--
  DO NOT EDIT THIS FILE.
  It was generated automatically by `org.apache.spark.SparkThrowableSuite`.
-->

[SQLSTATE: 22006](sql-error-conditions-sqlstates.html#class-22-data-exception)

Error parsing '`<input>`' to interval. Please ensure that the value provided is in a valid format for defining an interval. You can reference the documentation for the correct format.

This error class has the following derived error classes:

## ARITHMETIC_EXCEPTION

Uncaught arithmetic exception while parsing '`<input>`'.

## INPUT_IS_EMPTY

Interval string cannot be empty.

## INPUT_IS_NULL

Interval string cannot be null.

## INVALID_FRACTION

`<unit>` cannot have fractional part.

## INVALID_PRECISION

Interval can only support nanosecond precision, `<value>` is out of range.

## INVALID_PREFIX

Invalid interval prefix `<prefix>`.

## INVALID_UNIT

Invalid unit `<unit>`.

## INVALID_VALUE

Invalid value `<value>`.

## MISSING_NUMBER

Expect a number after `<word>` but hit EOL.

## MISSING_UNIT

Expect a unit name after `<word>` but hit EOL.

## UNKNOWN_PARSING_ERROR

Unknown error when parsing `<word>`.

## UNRECOGNIZED_NUMBER

Unrecognized number `<number>`.


